Package: personalr
Title: Automated Personal Package Setup
Version: 1.0.3
Authors@R: 
    person("Sebastian", "Carl", , "mrcaseb@gmail.com", role = c("aut", "cre"))
Description: Functions to setup a personal R package that attaches given
    libraries and exports personal helper functions.
License: MIT + file LICENSE
URL: https://mrcaseb.github.io/personalr/index.html,
        https://github.com/mrcaseb/personalr
BugReports: https://github.com/mrcaseb/personalr/issues
Imports: desc, devtools, fs, glue, magrittr, purrr, rprojroot,
        rstudioapi, usethis, utils, withr, xfun
Suggests: dplyr, tibble
Encoding: UTF-8
RoxygenNote: 7.2.1
NeedsCompilation: no
Packaged: 2022-08-11 21:42:08 UTC; S.Carl
Author: Sebastian Carl [aut, cre]
Maintainer: Sebastian Carl <mrcaseb@gmail.com>
Repository: CRAN
Date/Publication: 2022-08-11 22:00:02 UTC
Built: R 4.6.0; ; 2026-04-25 13:15:02 UTC; unix

<!-- README.md is generated from README.Rmd. Please edit that file -->

# personalr <img src='man/figures/logo.png' align="right" height="139" />

<!-- badges: start -->

[![CRAN
status](https://www.r-pkg.org/badges/version-ago/personalr)](https://CRAN.R-project.org/package=personalr)
[![CRAN
downloads](http://cranlogs.r-pkg.org/badges/grand-total/personalr)](https://CRAN.R-project.org/package=personalr)
[![Lifecycle:
stable](https://img.shields.io/badge/lifecycle-stable-brightgreen.svg)](https://lifecycle.r-lib.org/articles/stages.html#stable)
[![R-CMD-check](https://github.com/mrcaseb/personalr/actions/workflows/R-CMD-check.yaml/badge.svg)](https://github.com/mrcaseb/personalr/actions/workflows/R-CMD-check.yaml)
<!-- badges: end -->

## Preface

If you work with R or any other programming language for a while, you
will come to the point where you want to use already written code when
developing a script and often need the same packages to do your work.The
easiest solution is to save the loading of the regularly used packages
and maybe some helper functions in a separate script and then load this
script with `source(...)` into the Global Environment.

However, this approach has two disadvantages:

1.  Over time, the Global Environment becomes littered, making it harder
    to find important objects and
2.  The `source` script must either be available and up-to-date on the
    local machine or be made available on the Internet.

## Package Purpose

The best solution for the above mentioned disadvantages is an own
(personal) package, but for the setup it needs a basic understanding of
how to develop packages.

The goal of personalr is to do exactly that. A basic setup of a personal
package, which loads a modifiable list of packages and some basic
functions.

## Installation

You can install the released version of personalr from
[CRAN](https://cran.r-project.org/package=personalr) with:

``` r
install.packages("personalr")
```

You can install the development version from
[GitHub](https://github.com/mrcaseb/personalr/) with:

``` r
if (!require("pak")) install.packages("pak")
pak::pak("mrcaseb/personalr")
```

## One more thing

personalr is open source and it builds on top of other open source
projects. However, maintaining this package will be a lot of work so I
kindly ask you to consider donating at
[patreon](https://www.patreon.com/mrcaseb).

msg <- function(..., startup = FALSE) {
  if (startup) {
    if (!isTRUE(getOption("personalr_to_replace.quiet"))) {
      packageStartupMessage(text_col(...))
    }
  } else {
    message(text_col(...))
  }
}

text_col <- function(x) {
  # If RStudio not available, messages already printed in black
  if (!rstudioapi::isAvailable()) {
    return(x)
  }

  if (!rstudioapi::hasFun("getThemeInfo")) {
    return(x)
  }

  theme <- rstudioapi::getThemeInfo()

  if (isTRUE(theme$dark)) crayon::white(x) else crayon::black(x)

}

personalr_to_replace_packages <- function(include_self = TRUE) {
  raw <- utils::packageDescription("personalr_to_replace")$Imports
  imports <- strsplit(raw, ",")[[1]]
  parsed <- gsub("^\\s+|\\s+$", "", imports)
  names <- vapply(strsplit(parsed, "\\s+"), "[[", 1, FUN.VALUE = character(1))

  if (include_self) {
    names <- c(names, "personalr_to_replace")
  }

  names
}

invert <- function(x) {
  if (length(x) == 0) return()
  stacked <- utils::stack(x)
  tapply(as.character(stacked$ind), stacked$values, list)
}

personalr_to_replace_conflicts <- function() {
  envs <- grep("^package:", search(), value = TRUE)
  envs <- purrr::set_names(envs)
  objs <- invert(lapply(envs, ls_env))

  conflicts <- purrr::keep(objs, ~ length(.x) > 1)

  personalr_to_replace_names <-
    paste0("package:", personalr_to_replace_packages())
  conflicts <- purrr::keep(conflicts, ~ any(.x %in% personalr_to_replace_names))

  conflict_funs <- purrr::imap(conflicts, confirm_conflict)
  conflict_funs <- purrr::compact(conflict_funs)

  structure(conflict_funs, class = "personalr_to_replace_conflicts")
}

personalr_to_replace_conflict_message <- function(x) {
  if (length(x) == 0) {
    return("")
  }

  header <- cli::rule(
    left = crayon::bold("Conflicts"),
    right = "personalr_to_replace_conflicts()"
  )

  pkgs <- x %>% purrr::map(~ gsub("^package:", "", .))
  others <- pkgs %>% purrr::map(`[`, -1)
  other_calls <- purrr::map2_chr(
    others, names(others),
    ~ paste0(crayon::blue(.x), "::", .y, "()", collapse = ", ")
  )

  winner <- pkgs %>% purrr::map_chr(1)
  funs <- format(paste0(
    crayon::blue(winner),
    "::",
    crayon::green(paste0(names(x), "()"))
  ))
  bullets <- paste0(
    crayon::red(cli::symbol$cross), " ", funs,
    " masks ", other_calls,
    collapse = "\n"
  )

  paste0(header, "\n", bullets)
}


print.personalr_to_replace_conflicts <- function(x, ..., startup = FALSE) {
  cli::cat_line(personalr_to_replace_conflict_message(x))
}


confirm_conflict <- function(packages, name) {
  # Only look at functions
  objs <- packages %>%
    purrr::map(~ get(name, pos = .)) %>%
    purrr::keep(is.function)

  if (length(objs) <= 1) {
    return()
  }

  # Remove identical functions
  objs <- objs[!duplicated(objs)]
  packages <- packages[!duplicated(packages)]
  if (length(objs) == 1) {
    return()
  }

  packages
}

ls_env <- function(env) {
  x <- ls(pos = env)
  if (identical(env, "package:dplyr")) {
    x <- setdiff(x, c("intersect", "setdiff", "setequal", "union"))
  }
  x
}

core_unloaded <- function() {
  search <- paste0("package:", core)
  core[!search %in% search()]
}

# Attach the package from the same package library it was
# loaded from before. https://github.com/tidyverse/tidyverse/issues/171
same_library <- function(pkg) {
  loc <- if (pkg %in% loadedNamespaces()) dirname(getNamespaceInfo(pkg, "path"))
  do.call(
    "library",
    list(pkg, lib.loc = loc, character.only = TRUE, warn.conflicts = FALSE)
  )
}

personalr_to_replace_attach <- function() {
  to_load <- core_unloaded()
  if (length(to_load) == 0) {
    return(invisible())
  }

  msg(
    cli::rule(
      left = crayon::bold("Attaching packages"),
      right = crayon::cyan(crayon::bold(paste0(
        "personalr_to_replace ",
        package_version("personalr_to_replace")
      )))
    ),
    startup = TRUE
  )

  versions <- vapply(to_load, package_version, character(1))
  packages <- paste0(
    crayon::green(cli::symbol$tick), " ", crayon::cyan(format(to_load)), " ",
    crayon::col_align(versions, max(crayon::col_nchar(versions)))
  )

  if (length(packages) %% 2 == 1) {
    packages <- append(packages, "")
  }
  col1 <- seq_len(length(packages) / 2)
  info <- paste0(packages[col1], "     ", packages[-col1])

  msg(paste(info, collapse = "\n"), startup = TRUE)

  suppressPackageStartupMessages(
    lapply(to_load, same_library)
  )

  invisible()
}

package_version <- function(x) {
  version <- as.character(unclass(utils::packageVersion(x))[[1]])

  if (length(version) > 3) {
    version[4:length(version)] <-
      crayon::yellow(as.character(version[4:length(version)]))
  }
  paste0(version, collapse = ".")
}

#' @keywords internal
"_PACKAGE"

# The following block is used by usethis to automatically manage
# roxygen namespace tags. Modify with care!
## usethis namespace: start
## usethis namespace: end
NULL

.onAttach <- function(...) {
  needed <- core[!is_attached(core)]
  if (length(needed) == 0)
    return()

  crayon::num_colors(TRUE)
  personalr_to_replace_attach()

  # if (!"package:conflicted" %in% search()) {
  #   x <- personalr_to_replace_conflicts()
  #   msg(personalr_to_replace_conflict_message(x), startup = TRUE)
  # }

  msg(cli::rule(right = crayon::bold("Ready to go!")),startup = TRUE)

}

is_attached <- function(x) {
  paste0("package:", x) %in% search()
}
